<script setup>
import { useProductsStore } from "../../stores/products.js";

defineProps({
  product: Object
})

const emits = defineEmits(['add-item'])

const productsStore = useProductsStore()

const handleAdd = (item) => {
  emits('add-item', item)
}

const isProductInCart = (arr, val) => {
  return arr.some((arrVal) => val === arrVal.id);
}

const productStatus = (arr, val) => {
  return isProductInCart(arr, val) ? "Added" : "Add to basket"
}

const getDiscount = (price, oldprice) => {
  return ((oldprice-price)/oldprice * 100).toFixed(0)
}

const getStatusColour = (disabled) => {
  if (!disabled) {
    return "flex items-center justify-center font-medium w-full bg-black px-4 py-4 sm:px-6 text-md text-white hover:opacity-20"
  }
  return "flex items-center justify-center font-medium w-full bg-white border border-black px-4 py-4 sm:px-6 text-md text-black cursor-not-allowed"
}

const imageUrl = new URL(`../../assets/images/`, import.meta.url).href

</script>

<template>
  <div class="group relative">
    <div class="min-h-80 aspect-w-1 aspect-h-1 w-full overflow-hidden rounded-md bg-gray-200 group-hover:opacity-75 lg:aspect-h-1 w-full lg:h-80">
      <img
        class="h-full w-full object-cover object-center lg:h-full lg:w-full"
        :src="imageUrl + '/' + product.imageSrc"
        :alt="product.imageAlt"
      />
      <div 
        class="m-4 flex h-8 w-24 items-center ml-auto bg-amber-500"
        v-if="product.saleAmount && product.sale"
      >
        <p class="m-auto text-sm text-white">Sale -{{ getDiscount(product.price, product.oldPrice) }}%</p>
      </div>
    </div>
    <div class="mt-4 flex justify-between">
      <div>
        <h3 class="text-sm text-gray-700">
          <a :href="product.href">
            {{ product.name }}
          </a>
        </h3>
      </div>
    </div>
    <div class="flex flex-1 items-center justify-start space-x-2">
      <p class="text-sm font-medium text-gray-900">${{ product.price }}</p>
      <p 
        class="text-sm line-through font-medium text-gray-400"
        v-if="product.oldPrice"
      >
        ${{ product.oldPrice }}
      </p>
    </div>
    <button
      :class="getStatusColour(isProductInCart(productsStore.cart, product.id))"
      :disabled="isProductInCart(productsStore.cart, product.id)"
      @click="handleAdd(product)"
    >
      {{ productStatus(productsStore.cart, product.id) }}
    </button>

  </div>
</template>
